unit OLEInDBForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DBCtrls, OleCtnrs, Grids, DBGrids, ExtCtrls, DB,
  DBTables, ShellAPI;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    OleContainer1: TOleContainer;
    DBNavigator1: TDBNavigator;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Panel2: TPanel;
    OpenDialog1: TOpenDialog;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Table1AfterScroll(DataSet: TDataSet);
  private
    function SaveBlobToFile : String;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormShow(Sender: TObject);
begin
  Table1.Active := true;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  FileName, OLEData : String;
begin
  if (OpenDialog1.Execute) then
  begin
    FileName := OpenDialog1.FileName;
    with TFileStream.Create(FileName, fmOpenRead) do
    try
      SetLength(OLEData, Size);
      Read(Pointer(OLEData)^, Size);
    finally
      Free;
    end;
    if not (Table1.State in [dsEdit,dsInsert]) then
      Table1.Edit;
    Table1.FieldByName('OLE').AsString := OLEData;
    Table1.FieldByName('Name').Value := ExtractFileName(FileName);
  end;
end;

function TForm1.SaveBlobToFile: String;
var
  OLEData : String;
begin
  result := ExtractFilePath(Application.ExeName) + table1.FieldByName('Name').Value;
  OLEData := Table1.FieldByName('OLE').AsString;
  with TFileStream.Create(result, fmCreate) do
  try
    Write(Pointer(OLEData)^, Length(OLEData));
  finally
    Free;
  end;
end;

procedure TForm1.DBGrid1DblClick(Sender: TObject);
begin
  OleContainer1.CreateObjectFromFile(SaveBlobToFile, False);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ShellExecute(Handle,'open',PChar(SaveBlobToFile),nil,nil,SW_Normal);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ShellExecute(Handle,'print',PChar(SaveBlobToFile),nil,nil,SW_Normal);
end;

procedure TForm1.Table1AfterScroll(DataSet: TDataSet);
begin
  if (table1.FieldByName('Name').Value <> null) and (FileExists(ExtractFilePath(Application.ExeName) + table1.FieldByName('Name').Value)) then
    DeleteFile(ExtractFilePath(Application.ExeName) + table1.FieldByName('Name').Value);
end;

end.
